000100060623      * complete rewrite by Christian Vitroler of FTPAPI originally by
000101060623      * Scott C Klement, Thomas Raddatz and others
000102060626      * (please tell me if your name is missing here)
000103060623
000105060623      * This file contains constants and prototypes necessary for calling
000106060623      * procedures in the FTPAPI service program.
000107060623
000108060623     D FTPAPI_VERSION  C                   CONST('3.0')
000109060703     D FTPAPI_RELDATE  C                   CONST('2006-07-03')
000110060623
000111060623      * change those constants if they really do not fit your environment
000112060623
000113060623      * DFT_RMT_CP   CCSID used by the remote FTP server for the control
000114060623      *              channel & directory listings
000115060627
000118060627      * NOTE: any standards compliant FTP server would use 367, but iconv()
000119060627      *       on the iSeries can convert that code page only into very few
000120060707      *       host CCSIDs; as of V5R4 those would be:
000121060627      *       00037, 00500, 00833, 01200, 01208, 13121, 13124, 13488, 61952
000122060627      *
000123060627      *       on the data channel the iSeries uses 819 for the *data*
000124060627      *       channel anyway; thus, to make things work, we assume that
000125060627      *       ISO-8859-1 is used on the control channel as well
000126060627      *
000127060627      *       any decent FTP server would support UTF-8 as per RFC 2640;
000128060627      *       this API supports UTF-8 (transparently), the IBM server
000131060623      *       (as of V5R3) does *not*
000132060627
000133060623      * DFT_LOC_CP   local CCSID; uses the job CCSID; if in any case your
000134060623      *              job runs with 65535, put your preferred CCSID here
000135060623
000136060623      * DFT_MODE     file creation mode for IFS files which DO NOT EXIST YET
000137060623      *              grants all rights to everyone
000138060623
000139060623      * FTP_PORT     default port for FTP control channel connections
000140060627
000141060623
000142060627     D DFT_RMT_CP      C                   819
000143060627     D DFT_LCL_CP      C                   0
000144060627      * for compatibilty with old version of FTPAPI
000145060626     D DFT_LOC_CP      C                   0
000146060623
000147060623     D DFT_MODE        C                   511
000148060623
000149060623     D FTP_PORT        C                   21
000150060623
000151060626
000152060629      * Bad IP address / Host Not found
000153060629     D FTP_BADHOST     C                   4
000154060629     D FTP_BADIP       C                   4
000155060630      * Invalid Login Password (or name?)
000156060629     D FTP_BADPAS      C                   5
000157060629      * Invalid response from FTP server
000158060629     D FTP_BADRES      C                   6
000159060704      * Invalid response to FTP RETR (get) command
000160060704     D FTP_BADRTR      C                   7
000161060704      * Invalid response to FTP STOR (put) command
000162060704     D FTP_BADSTO      C                   8
000163060704      * Invalid user name
000164060629     D FTP_BADUSR      C                   9
000165060629      * Connection dropped
000166060629     D FTP_DISCON      C                   10
000167060629      * Error connecting to host(control channel)
000168060629     D FTP_ERRCON      C                   13
000169060705      * Error changing working directory
000170060705     D FTP_ERRCWD      C                   14
000171060705      * Error creating a new socket
000172060629     D FTP_ERRSKT      C                   15
000173060703      * Server does not properly understand passive mode
000174060703     D FTP_PASERR      C                   20
000175060703      * Unable to find connection details in passive response
000176060703     D FTP_PASRPY      C                   21
000177060704      * File transfer did not complete normally.
000178060704     D FTP_XFRERR      C                   26
000179060704      * Unable to open the local file...
000180060704     D FTP_OPNERR      C                   27
000181060704      * No such file or directory....
000182060704     D FTP_NOFILE      C                   29
000183060704      * Bad response to NLST command...
000184060704     D FTP_BADNLS      C                   30
000185060704      * Unable to retrieve modification time
000186060630     D FTP_MODERR      C                   40
000187060630      * Unable to parse modification time
000188060630     D FTP_MODPRS      C                   41
000189060630      * Time-out occurred
000190060629     D FTP_TIMOUT      C                   71
000191060630      * Server did not like the account we sent to it
000192060629     D FTP_BADACT      C                   72
000193060629      * Session handle not found
000194060629     D FTP_BADHDL      C                   74
000195060629
000196060629      * error during character conversion
000197060629     D FTP_ERRCONV     C                   77
000198060629      * error during sending
000199060629     D FTP_ERRSEND     C                   78
000200060629      * error during receiving
000201060629     D FTP_ERRRECV     C                   79
000202060629
000203060623      *#########################################################################
000204060623      *  exported procedures (the API proper)
000205060623      *#########################################################################
000206060623
000207060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000208060623      * FTP_Conn:  connect *and* log-in to a FTP server
000209060623      *
000210060623      *     peHost = host name of FTP server to connect to
000211060623      *     peUser = user name on FTP server (or "anonymous")
000212060623      *     pePass = password for user name supplied (or "email@user.com")
000213060623      *     pePort = (optional) port to connect to; if not supplied,
000214060623      *              the value of the constant FTP_PORT will be used
000215060623      *  peTimeout = (optional) number of seconds to wait for data before
000216060623      *              assuming the connection is dead and giving up;
000217060623      *              if not given or set to 0, we wait indefinitely
000218060623      *     peAcct = (optional) account name (if required by server)
000219060623      *              if not given, a blank account name will be tried
000220060623      *              if the server requests an account name
000221060623      *
000222060623      * returns the session handle of the connection upon success
000223060623      *         or -1 upon error
000224060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000225060623     D FTP_Conn        PR            10I 0
000226060623     D   peHost                     256A   const
000227060623     D   peUser                      32A   const
000228060623     D   pePass                      64A   const
000229060623     D   pePort                      10I 0 value options(*nopass)
000230060623     D   peTimeout                   10I 0 value options(*nopass)
000231060623     D   peAcct                      32A   const options(*nopass)
000232060623
000233060623
000234060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000235060623      *  FTP_Open: open a connection to a FTP server
000236060623      *
000237060623      *     peHost = host name of FTP server to connect to
000238060623      *     pePort = (optional) port to connect to; if not supplied,
000239060623      *              the value of the constant FTP_PORT will be used
000240060623      *  peTimeout = (optional) number of seconds to wait for data before
000241060623      *              assuming the connection is dead and giving up;
000242060623      *              if not given or set to 0, we wait indefinitely
000243060623      *
000244060623      * returns the session handle of the connection upon success
000245060623      *         or -1 upon error
000246060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000247060623     D FTP_Open        PR            10I 0
000248060623     D   peHost                     256A   const
000249060623     D   pePort                      10I 0 value options(*nopass)
000250060623     D   peTimeout                   10I 0 value options(*nopass)
000251060623
000252060623
000253060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000254060704      *  FTP_Login: log-in to an already connected FTP server
000255060626      *
000256060704      *  peHandle = session handle returned by FTP_Open()
000257060704      *  peUser   = user name on FTP server (or "anonymous")
000258060704      *  pePass   = password for user name supplied (or "email@user.com")
000259060704      *  peAcct   = (optional) account name (if required by server)
000260060704      *             if not given, a blank account name will be tried
000261060704      *             if the server requests an account name
000262060623      *
000263060623      *  returns 0 upon success or -1 upon error
000264060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000265060623     D FTP_Login       PR            10I 0
000266060623     D   peHandle                    10I 0 value
000267060623     D   peUser                      32A   const
000268060623     D   pePass                      64A   const options(*nopass)
000269060623     D   peAcct                      32A   const options(*nopass)
000270060623
000271060623
000272060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000273060623      * FTP_Quit: quit connection to FTP server and release session
000274060623      *
000275060623      *   peHandle = session handle returned by FTP_Conn() or FTP_Open()
000276060623      *
000277060623      *  this procedure logs off of the FTP server and closes the network
000278060623      *  connection; relases internal data
000279060623      *
000280060623      *  returns 0 upon success or -1 upon error
000281060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000282060623     D FTP_Quit        PR            10I 0
000283060623     D   peHandle                    10I 0 value
000284060623
000285060703
000286060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000287060704      *  FTP_List: get a file list of a remote directory (on the FTP server)
000288060704      *            (filenames only)
000289060703      *
000290060704      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000291060704      *  peRmtPath  = remote path, used for NLIST command; usually generic
000292060704      *               something like '*.txt' or '/windows/*.exe'
000293060704      *  peMaxCount = max number of directory entries to return
000294060704      *             = (usually the actual array size)
000295060704      *  peDirList  = pointer to an array; each filename in the remote dir
000296060704      *               returned by the server will be placed into this
000297060704      *               array, up to the max number of entries (above)
000298060704      *  peRmtCount = actual number of  elements that could have been returned
000299060704      *               (could be larger than peMaxCount; increase array size)
000300060703      *
000301060703      *  returns 0 upon success or -1 upon error
000302060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000303060703     D FTP_List        PR            10I 0
000304060703     D   peHandle                    10I 0 value
000305060703     D   peRmtPath                  256A   const
000306060703     D   peMaxCount                  10I 0 value
000307060703     D   peDirList                     *   value
000308060703     D   peRmtCount                  10I 0
000309060703
000310060703
000311060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000312060703      * FTP_LstRaw: get a file list of a remote directory (on the FTP server)
000313060703      *             (filenames only)
000314060703      *             storage of the result list is handled by peFunction
000315060703      *
000316060703      *   peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000317060703      *   peRmtPath  = remote path, used for NLISt command; usually generic
000318060703      *                something like '*.txt' or '/windows/*.exe'
000319060703      *   peDescr    = descriptor to pass to peFunction below
000320060703      *                (if peFunction writes to a file, that would the file descr
000321060703      *                of the open file to write the output to)
000322060703      *   peFunction = procedure to store each line of the directory list
000323060703      *
000324060703      *  returns 0 upon success or -1 upon error
000325060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000326060703     D FTP_LstRaw      PR            10I 0
000327060703     D   peHandle                    10I 0 value
000328060703     D   peRmtPath                  256A   const
000329060703     D   peDescr                     10I 0 value
000330060703     D   peFunction                    *   value procptr
000331060703
000332060705
000333060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000334060705      *  FTP_BinaryMode: set file transfer mode to/from binary mode
000335060705      *
000336060705      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000337060705      *  peSetting  = setting of binary mode *ON  = turn binary mode on
000338060705      *                                      *OFF = turn binary mode off
000339060705      *
000340060705      *  returns 0 upon success or -1 upon error
000341060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000342060705     D FTP_BinaryMode  PR            10I 0
000343060705     D   peHandle                    10I 0 value
000344060705     D   peSetting                     N   value
000345060705
000346060705
000347060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000348060705      *  FTP_ChDir: change current directory on FTP server
000349060705      *
000350060705      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000351060705      *  peChgDir   = directory to change to
000352060705      *
000353060705      *  returns 0 upon success or -1 upon error
000355060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000356060705     D FTP_ChDir       PR            10I 0
000357060705     D   peHandle                    10I 0 value
000358060705     D   peChgDir                   256A   const
000359060705
000360060704
000361060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000362060704      *  FTP_CodePage: set file translation CCSIDs for ASCII mode
000363060704      *
000364060704      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000365060704      *  peRmtCCSID = CCSID of the remote server
000366060704      *  peLclCCSID = CCSID of the local host
000367060704      *
000368060704      *  returns 0 upon success or -1 upon error
000369060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000370060704     D FTP_CodePage    PR            10I 0
000371060704     D   peHandle                    10I 0 value
000372060704     D   peRmtCCSID                  10I 0 value
000373060704     D   peLclCCSID                  10I 0 value
000374060704
000375060704
000376060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000377060704      *  FTP_Get: retrieve a file from a FTP server
000378060704      *
000379060704      *   peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000380060704      *   peRmtPath  = remote file name (on server)
000381060704      *   peLclPath  = local file name ("NAMEFMT 1")
000382060704      *                (can be omitted for backwards compatibility)
000383060704      *
000384060704      *  returns 0 upon success or -1 upon error
000385060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000386060704     D FTP_Get         PR            10I 0
000387060704     D   peHandle                    10I 0 value
000388060704     D   peRmtPath                  256A   const
000389060704     D   peLclPath                  256A   const options(*nopass)
000390060704
000391060705
000392060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000393060705      *  FTP_Put: send a file to a FTP server
000394060705      *
000396060705      *   peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000397060705      *   peRmtPath  = remote file name (on server)
000398060705      *   peLclPath  = local file name ("NAMEFMT 1")
000399060705      *                (can be omitted for backwards compatibility)
000400060705      *
000401060705      *  returns 0 upon success or -1 upon error
000402060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000403060705     D FTP_Put         PR            10I 0
000404060705     D   peHandle                    10I 0 value
000405060705     D   peRmtPath                  256A   const
000406060705     D   peLclPath                  256A   const options(*nopass)
000407060705
000408060623
000409060630      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000410060705      *  FTP_MTime: get modification time of a file on a FTP server
000411060630      *
000412060705      *  NOTE: this is not part of the official FTP standard, and is not
000413060630      *       supported by some FTP servers, INCLUDING THE AS/400 FTP SERVER
000414060630      *
000415060705      *  peHandle  = session handle returned by FTP_Conn() or FTP_Open()
000416060705      *  peFile    = file to look up the size of
000417060630      *  peModTime = Modification time returned by server
000418060630      *
000419060630      *  returns 0 upon success or -1 upon error
000420060630      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000421060707     D FTP_MTime       PR            10I 0
000422060630     D   peHandle                    10I 0 value
000423060630     D   peFile                     256A   const
000424060630     D   peModTime                     Z
000425060630
000426060705
000427060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000428060705      *  FTP_ErrorMsg: returns the error message that occurred when one of the
000429060705      *  above routines returned failure
000430060705      *
000431060705      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
000432060705      *  peErrorNum = numerical error code
000433060705      *
000434060705      *  optionally also returns the error number, which will match one of the
000435060705      *  constants defined in FTPAPI_H. This can be used by programs to
000436060705      *  anticipate/handle errors
000437060705      *
000438060705      *  NOTE: this will actually return the last error stored, even if the last
000439060705      *        call to an API procedure has been successful; thus call early!
000440060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000441060705     D FTP_ErrorMsg    PR            60A
000442060705     D   peHandle                    10I 0 value
000443060705     D   peErrorNum                  10I 0 options(*nopass)
000444060705
